import os
import re
import sys
import json
import config
import requests
import pandas as pd
from datetime import date,datetime, timedelta, timezone

# 載入參數
# OmniSegment API參數
OG_CONFIG = config.OG_CONFIG

directory = os.path.dirname(os.path.abspath(__file__)) # 取路徑
file_name = str(sys.argv[0]).split("/") # 取輸入路徑
file_name = file_name[file_name.index(max(file_name))].split(".")
file_name = file_name[0] # 取執行檔名
logFileName = file_name+'_'+datetime.today().strftime("%Y_%m_%d_%H_%M_%S")+'.txt' # logs檔名

def now():
    tz = timezone(timedelta(hours=+8))
    return datetime.now(tz).strftime("%Y-%m-%d %H:%M:%S")

def today():
    tz = timezone(timedelta(hours=+8))
    return datetime.now(tz).strftime("%Y-%m-%d")

def datelist(beginDate, endDate):
    date = [datetime.strftime(x,'%Y-%m-%d') for x in list(pd.date_range(start = beginDate, end = endDate))]
    return date

def logTxt(msg):
        filename = f"{directory+'/logs/'+logFileName}"
        f = open(filename, "a")
        f.write("{0} -- {1}\n".format(now(), msg))
        f.close()

def omni_api(method="audience",data: dict = {}):
    url = OG_CONFIG[method]['url']
    headers = {"Content-Type": "application/json;"}
    json = {
        "tid": OG_CONFIG['tid'],
        "api_key": OG_CONFIG['api_key'],
        "data": data,
    }
    response = requests.post(url, headers = headers, json = json)
    logTxt(json)
    logTxt('status:'+str(response.status_code))
    logTxt(response.json())
    return {
        'status' :response.status_code,
        'json' : response.json()
    }

def format_json(data: json = {}):
    return json.dumps(data, indent=2, sort_keys=True, default=str,ensure_ascii=False)

def pattern_886(mobile: str = ''):
    return re.sub(r'^\d{1}', '+886', mobile) if re.findall(r'^09\d{8}$',mobile) else mobile

# 取得 N 天前的日期
# return [前日期,今日期]
def get_ago_date(num):
    return { 'start' : datetime.strftime((date.today()-timedelta(days=num)),'%Y/%m/%d'), 'end' : datetime.strftime((date.today()-timedelta(days=1)),'%Y/%m/%d') }

class create_dict(dict): 
    def __init__(self): 
        self = dict()

    def add(self, key, value): 
        self[key] = value



